"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var subscription_parser_1 = require("./subscription_parser");
var parse = require('fast-json-parse');
test('Parse a SOAP XML with embedded JSON', function () { return __awaiter(void 0, void 0, void 0, function () {
    var xml, soapParser, subscriptionReq, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                xml = fs.readFileSync('./data/test_2.xml');
                soapParser = new subscription_parser_1.SubscriptionParser();
                subscriptionReq = [
                    { tag: 'Envelope.Body.pa.paReq.refId', name: 'refId' },
                    { tag: 'Envelope.Body.pa.paReq.ced.id', name: 'ids' },
                    { tag: 'Envelope.Header.activity.activityDetails.activityId', name: 'actId' },
                    { tag: 'Envelope.Body.dataJson', name: 'json', converter: dataJsonConverter },
                ];
                return [4 /*yield*/, soapParser.subscribe(subscriptionReq).parse(xml)];
            case 1:
                response = _a.sent();
                expect(response).toBeDefined();
                expect(response.refId).toBe('cliRefId');
                expect(response.ids).toBeDefined();
                expect(response.ids.length).toBe(2);
                expect(response.ids[0]).toBe('crn-1');
                expect(response.ids[1]).toBe('crn-2');
                expect(response.actId).toBe('actID');
                expect(response.json).toBeDefined();
                expect(response.json.x).toBe('a');
                return [2 /*return*/];
        }
    });
}); });
test('Parse a SOAP XML with embedded JSON in CDATA', function () { return __awaiter(void 0, void 0, void 0, function () {
    var xml, soapParser, subscriptionReq, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                xml = fs.readFileSync('./data/test_3.xml');
                soapParser = new subscription_parser_1.SubscriptionParser();
                subscriptionReq = [
                    { tag: 'Envelope.Body.operation.data', name: 'data', converter: dataJsonConverter },
                ];
                return [4 /*yield*/, soapParser.subscribe(subscriptionReq).parse(xml)];
            case 1:
                response = _a.sent();
                expect(response).toBeDefined();
                expect(response.data).toBeDefined();
                expect(response.data.businessTransactionType).toBe('abc');
                return [2 /*return*/];
        }
    });
}); });
var dataJsonConverter = new (/** @class */ (function () {
    function DataJsonConverter() {
    }
    DataJsonConverter.prototype.convert = function (value) {
        var result = parse(value);
        if (result.err) {
            throw result.err;
        }
        return result.value;
    };
    return DataJsonConverter;
}()))();
